import File = require('vinyl');
import { IEnvironment, IUserCredentials } from 'sp-request';
export declare enum CheckinType {
    minor = 0,
    major = 1,
    overwrite = 2,
}
export interface ICoreOptions {
    siteUrl: string;
    checkin?: boolean;
    checkinType?: CheckinType;
    checkinMessage?: string;
    notification?: boolean;
}
export interface IGlobOptions {
    glob: string | string[];
    folder?: string;
    base?: string;
}
export interface IFileContentOptions {
    fileName: string;
    fileContent: string | Buffer;
    folder: string;
}
export interface IVinylOptions {
    file: File;
    folder?: string;
}
export declare type CoreOptions = ICoreOptions & IEnvironment & IUserCredentials;
export declare type GlobOptions = CoreOptions & IGlobOptions;
export declare type FileContentOptions = CoreOptions & IFileContentOptions;
export declare type VinylOptions = CoreOptions & IVinylOptions;
export declare type SPSaveOptions = GlobOptions | FileContentOptions | VinylOptions;
export declare function isGlobOptions(T: any): T is GlobOptions;
export declare function isFileContentOptions(T: any): T is FileContentOptions;
export declare function isVinylOptions(T: any): T is VinylOptions;
